
#include <stdio.h>
#include <stdlib.h>
#include <SDL.h>
#include <SDL_mixer.h>

Mix_Music *music=NULL;

int handleKey(SDL_KeyboardEvent key);
void musicDone();

int main(void)
{
    SDL_Surface *screen;
    SDL_Event event;
    int done = 0;

    int audio_rate = 22050;
    Uint16 audio_format = AUDIO_S16; // 16 bit stereo
    int audio_channels = 2;
    int audio_buffers = 4096;

    SDL_Init(SDL_INIT_VIDEO | SDL_INIT_AUDIO);

    if(Mix_OpenAudio(audio_rate, audio_format, audio_channels, audio_buffers))
    {
        printf("Unable to open audio\n");
        exit(1);
    }
 
    screen = SDL_SetVideoMode(320,240,0,0);

    while(!done){
      while(SDL_PollEvent(&event)){
        switch(event.type){
        case SDL_KEYDOWN:
        case SDL_KEYUP:
          done=handleKey(event.key);
          break;
        }
      }
    }
printf("Done is %i\n",done);

    //Mix_HookMusicFinished(musicDone);
    SDL_Delay(50);
    Mix_CloseAudio();
    SDL_Quit();
}

    int handleKey(SDL_KeyboardEvent key){
      switch(key.keysym.sym){
      case SDLK_m:
      if(key.state == SDL_PRESSED){
        if(music == NULL) {
          music = Mix_LoadMUS("towne3.it");
          Mix_PlayMusic(music,-1); // klapse loop forever with -1 or set to 0 to loop once
          Mix_VolumeMusic(32); // klapse set music volume 
          Mix_HookMusicFinished(musicDone);
        } else {
          Mix_HaltMusic();
          Mix_FreeMusic(music);
        }
      break;
      case SDLK_q:
      if(key.state == SDL_PRESSED){
	  exit(1);
      }
      break;
      return(0);
    }
  }
} // end main()

void musicDone(){
    printf("Music Loop!!\n");
    Mix_PlayMusic(music,0); // klapse loop forever with -1 or set to 0 to loop once
    Mix_VolumeMusic(32); // klapse reduce music volume again
    //Mix_HaltMusic();
    //Mix_FreeMusic(music);
    //music = NULL;
}

